Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limupdate2.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limupdate2.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limupdate2.F90	(revision 4333)
@@ -45,9 +45,5 @@
    PUBLIC   lim_update2   ! routine called by ice_step
 
-      REAL(wp)  ::   epsi06 = 1.e-06_wp   ! module constants
-      REAL(wp)  ::   epsi04 = 1.e-04_wp   !    -       -
       REAL(wp)  ::   epsi10 = 1.e-10_wp   !    -       -
-      REAL(wp)  ::   epsi16 = 1.e-16_wp   !    -       -
-      REAL(wp)  ::   epsi20 = 1.e-20_wp   !    -       -
       REAL(wp)  ::   rzero  = 0._wp       !    -       -
       REAL(wp)  ::   rone   = 1._wp       !    -       -
@@ -102,34 +98,18 @@
       CALL wrk_alloc( jpi,jpj,jpl,zviold, zvsold, zsmvold )   ! clem
 
-      !------------------------------------------------------------------------------
-      ! 1. Update of Global variables                                               |
-      !------------------------------------------------------------------------------
-
-      !-----------------------------
-      ! Update ice and snow volumes  
-      !-----------------------------
-      DO jl = 1, jpl
-         v_i(:,:,jl)  = v_i(:,:,jl) + d_v_i_thd(:,:,jl) 
-         v_s(:,:,jl)  = v_s(:,:,jl) + d_v_s_thd(:,:,jl)
-      END DO
- 
-      !---------------------------------------------
-      ! Ice concentration and ice heat content
-      !---------------------------------------------
-      a_i (:,:,:) = a_i (:,:,:) + d_a_i_thd(:,:,:)
-      e_i(:,:,:,:) = e_i(:,:,:,:) + d_e_i_thd(:,:,:,:)  
- 
-      !------------------------------
-      ! Snow temperature and ice age
-      !------------------------------
-      e_s (:,:,:,:) = e_s (:,:,:,:) + d_e_s_thd (:,:,:,:)
-      oa_i(:,:,:)   = oa_i(:,:,:)   + d_oa_i_thd(:,:,:)
-
-      !--------------
-      ! Ice salinity    
-      !--------------
-      IF(  num_sal == 2  ) THEN      ! general case
-         smv_i(:,:,:) = smv_i(:,:,:) + d_smv_i_thd(:,:,:)
-      ENDIF
+      !----------------------------------------------------------------------------------------
+      ! 1. Computation of trend terms      
+      !----------------------------------------------------------------------------------------
+      !- Trend terms
+      d_a_i_thd(:,:,:)   = a_i(:,:,:)   - old_a_i(:,:,:) 
+      d_v_s_thd(:,:,:)   = v_s(:,:,:)   - old_v_s(:,:,:)
+      d_v_i_thd(:,:,:)   = v_i(:,:,:)   - old_v_i(:,:,:)  
+      d_e_s_thd(:,:,:,:) = e_s(:,:,:,:) - old_e_s(:,:,:,:) 
+      d_e_i_thd(:,:,:,:) = e_i(:,:,:,:) - old_e_i(:,:,:,:)
+      !?? d_oa_i_thd(:,:,:)  = oa_i (:,:,:) - old_oa_i (:,:,:)
+      d_smv_i_thd(:,:,:) = 0._wp
+      IF( num_sal == 2 )   d_smv_i_thd(:,:,:) = smv_i(:,:,:) - old_smv_i(:,:,:)
+      ! diag only (clem)
+      dv_dt_thd(:,:,:) = d_v_i_thd(:,:,:) * r1_rdtice * rday
 
       ! mass and salt flux init (clem)
@@ -151,98 +131,52 @@
       CALL lim_var_glo2eqv
 
-      !---------------------------------
-      ! Classify the pathological cases
-      !---------------------------------
-      ! (1) v_i (new) > 0; d_v_i_thd + v_i(old) > 0 (easy case)
-      ! (2) v_i (new) > 0; d_v_i_thd + v_i(old) = 0 (total thermodynamic ablation)
-      ! (3) v_i (new) < 0; d_v_i_thd + v_i(old) > 0 (combined total ablation)
-      ! (4) v_i (new) < 0; d_v_i_thd + v_i(old) = 0 (total thermodynamic ablation 
-      ! with negative advection, very pathological )
-      !
-      DO jl = 1, jpl
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               patho_case(ji,jj,jl) = 1
-               IF( v_i(ji,jj,jl) .GE. 0.0 ) THEN
-                  IF ( old_v_i(ji,jj,jl) + d_v_i_thd(ji,jj,jl) .LT. epsi10 ) THEN 
-                     patho_case(ji,jj,jl) = 2
-                  ENDIF
-               ELSE
-                  patho_case(ji,jj,jl) = 3
-                  IF( old_v_i(ji,jj,jl) + d_v_i_thd(ji,jj,jl) .LT. epsi10 ) THEN 
-                     patho_case(ji,jj,jl) = 4
-                  ENDIF
-               ENDIF
-             END DO
-         END DO
-      END DO
-
       !--------------------------------------
       ! 2. Review of all pathological cases
       !--------------------------------------
+
+! clem: useless now
       !-------------------------------------------
       ! 2.1) Advection of ice in an ice-free cell
       !-------------------------------------------
       ! should be removed since it is treated after dynamics now
-
-!      !IF( ln_nicep ) THEN  
-!         WRITE(numout,*) ' limupdate2 - before h correction '
-!         WRITE(numout,*) ' a_i  : ', a_i(12, 44, 1:jpl)
-!         WRITE(numout,*) ' at_i : ', at_i(12,44)
-!         WRITE(numout,*) ' v_i  : ', v_i(12, 44, 1:jpl)
-!         WRITE(numout,*) ' ht_i : ', ht_i(12, 44, 1:jpl)
-!      !ENDIF
-
-      zhimax = 5._wp
-      ! first category
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            !--- the thickness of such an ice is often out of bounds
-            !--- thus we recompute a new area while conserving ice volume
-            zat_i_old = SUM( old_a_i(ji,jj,:) )
-            zindb     = MAX( 0._wp, SIGN( 1._wp, ABS( d_a_i_thd(ji,jj,1) ) - epsi10 ) ) 
-            IF ( ( ABS( d_v_i_thd(ji,jj,1) ) / MAX( ABS( d_a_i_thd(ji,jj,1) ),epsi10 ) * zindb .GT. zhimax ) &
-               &  .AND. ( ( v_i(ji,jj,1) / MAX( a_i(ji,jj,1), epsi10 ) * zindb ) .GT. zhimax ) &
-               &  .AND. ( zat_i_old .LT. 1.e-6 ) )  THEN ! new line
-               ht_i(ji,jj,1) = hi_max(1) * 0.5_wp
-               a_i (ji,jj,1) = v_i(ji,jj,1) / ht_i(ji,jj,1)
-            ENDIF
-         END DO
-      END DO
-
-!      !IF( ln_nicep ) THEN  
-!         at_i(:,:) = 0._wp
-!         DO jl = 1, jpl
-!            at_i(:,:) = a_i(:,:,jl) + at_i(:,:)
+!      zhimax = 5._wp
+!      ! first category
+!      DO jj = 1, jpj
+!         DO ji = 1, jpi
+!            !--- the thickness of such an ice is often out of bounds
+!            !--- thus we recompute a new area while conserving ice volume
+!            zat_i_old = SUM( old_a_i(ji,jj,:) )
+!            zindb     = MAX( 0._wp, SIGN( 1._wp, ABS( d_a_i_thd(ji,jj,1) ) - epsi10 ) ) 
+!            IF ( ( ABS( d_v_i_thd(ji,jj,1) ) / MAX( ABS( d_a_i_thd(ji,jj,1) ),epsi10 ) * zindb .GT. zhimax ) &
+!               &  .AND. ( ( v_i(ji,jj,1) / MAX( a_i(ji,jj,1), epsi10 ) * zindb ) .GT. zhimax ) &
+!               &  .AND. ( zat_i_old .LT. 1.e-6 ) )  THEN ! new line
+!               ht_i(ji,jj,1) = hi_max(1) * 0.5_wp
+!               a_i (ji,jj,1) = v_i(ji,jj,1) / ht_i(ji,jj,1)
+!            ENDIF
 !         END DO
-!         WRITE(numout,*) ' limupdate2 - after h correction 1 '
-!         WRITE(numout,*) ' a_i  : ', a_i(12, 44, 1:jpl)
-!         WRITE(numout,*) ' at_i : ', at_i(12,44)
-!         WRITE(numout,*) ' v_i  : ', v_i(12, 44, 1:jpl)
-!         WRITE(numout,*) ' ht_i : ', ht_i(12, 44, 1:jpl)
-!      !ENDIF
-! 
-      zhimax = 20._wp
-      ! other categories
-      DO jl = 2, jpl
-         jm = ice_types(jl)
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               zindb =  MAX( rzero, SIGN( rone, ABS( d_a_i_thd(ji,jj,jl)) - epsi10 ) ) 
-              ! this correction is very tricky... sometimes, advection gets wrong i don't know why
-               ! it makes problems when the advected volume and concentration do not seem to be 
-               ! related with each other
-               ! the new thickness is sometimes very big!
-               ! and sometimes d_a_i_trp and d_v_i_trp have different sign
-               ! which of course is plausible
-               ! but fuck! it fucks everything up :)
-               IF ( ( ABS( d_v_i_thd(ji,jj,jl) ) / MAX( ABS( d_a_i_thd(ji,jj,jl) ), epsi10 ) * zindb .GT. zhimax ) &
-                  &  .AND. ( v_i(ji,jj,jl) / MAX( a_i(ji,jj,jl), epsi10 ) * zindb ) .GT. zhimax ) THEN
-                  ht_i(ji,jj,jl) = ( hi_max_typ(jl-ice_cat_bounds(jm,1),jm) + hi_max_typ(jl-ice_cat_bounds(jm,1)+1,jm) ) * 0.5_wp
-                  a_i (ji,jj,jl) = v_i(ji,jj,jl) / ht_i(ji,jj,jl)
-               ENDIF
-            END DO ! ji
-         END DO !jj
-      END DO !jl
+!      END DO
+
+!      zhimax = 20._wp
+!      ! other categories
+!      DO jl = 2, jpl
+!         jm = ice_types(jl)
+!         DO jj = 1, jpj
+!            DO ji = 1, jpi
+!               zindb =  MAX( rzero, SIGN( rone, ABS( d_a_i_thd(ji,jj,jl)) - epsi10 ) ) 
+!              ! this correction is very tricky... sometimes, advection gets wrong i don't know why
+!               ! it makes problems when the advected volume and concentration do not seem to be 
+!               ! related with each other
+!               ! the new thickness is sometimes very big!
+!               ! and sometimes d_a_i_trp and d_v_i_trp have different sign
+!               ! which of course is plausible
+!               ! but fuck! it fucks everything up :)
+!               IF ( ( ABS( d_v_i_thd(ji,jj,jl) ) / MAX( ABS( d_a_i_thd(ji,jj,jl) ), epsi10 ) * zindb .GT. zhimax ) &
+!                  &  .AND. ( v_i(ji,jj,jl) / MAX( a_i(ji,jj,jl), epsi10 ) * zindb ) .GT. zhimax ) THEN
+!                  ht_i(ji,jj,jl) = ( hi_max_typ(jl-ice_cat_bounds(jm,1),jm) + hi_max_typ(jl-ice_cat_bounds(jm,1)+1,jm) ) * 0.5_wp
+!                  a_i (ji,jj,jl) = v_i(ji,jj,jl) / ht_i(ji,jj,jl)
+!               ENDIF
+!            END DO ! ji
+!         END DO !jj
+!      END DO !jl
      
       at_i(:,:) = 0._wp
@@ -250,12 +184,4 @@
          at_i(:,:) = a_i(:,:,jl) + at_i(:,:)
       END DO
-
-!      !IF( ln_nicep ) THEN  
-!         WRITE(numout,*) ' limupdate2 - after h correction 2 '
-!         WRITE(numout,*) ' a_i  : ', a_i(12, 44, 1:jpl)
-!         WRITE(numout,*) ' at_i : ', at_i(12,44)
-!         WRITE(numout,*) ' v_i  : ', v_i(12, 44, 1:jpl)
-!         WRITE(numout,*) ' ht_i : ', ht_i(12, 44, 1:jpl)
-!      !ENDIF
 
       !----------------------------------------------------
@@ -304,7 +230,4 @@
                      zesum = zesum + e_i(ji,jj,jk,jl)
                   END DO
-                  !clem IF (ind_im .LT. nlay_i ) THEN
-                  !clem   smv_i(ji,jj,jl) = smv_i(ji,jj,jl) / ht_i(ji,jj,jl) * ( ht_i(ji,jj,jl) - REAL(ind_im)*ht_i(ji,jj,jl) / REAL(nlay_i) )
-                  !clem ENDIF
                   ht_i(ji,jj,jl) = ht_i(ji,jj,jl) - REAL(ind_im)*ht_i(ji,jj,jl) / REAL(nlay_i)
                   v_i(ji,jj,jl)  = ht_i(ji,jj,jl) * a_i(ji,jj,jl)
@@ -368,5 +291,6 @@
             DO ji = 1, jpi
                ! snow energy of melting
-               ze_s = e_s(ji,jj,1,jl) * unit_fac / area(ji,jj) / MAX( v_s(ji,jj,jl), 1.0e-6 )  ! snow energy of melting
+               zinda   =  MAX( 0._wp, SIGN( 1._wp, v_s(ji,jj,jl) - epsi10 ) )
+               ze_s = zinda * e_s(ji,jj,1,jl) * unit_fac / area(ji,jj) / MAX( v_s(ji,jj,jl), epsi10 )  ! snow energy of melting
 
                ! If snow energy of melting smaller then Lf
@@ -401,8 +325,8 @@
 
                !switches
-               zindb         = MAX( rzero, SIGN( rone, a_i(ji,jj,jl) - epsi06 ) ) 
+               zindb         = MAX( rzero, SIGN( rone, a_i(ji,jj,jl) - epsi10 ) ) 
                !switch = 1 if a_i > 1e-06 and 0 if not
-               zindsn        = MAX( rzero, SIGN( rone, v_s(ji,jj,jl) - epsi06 ) ) !=1 if hs > 1e-6 and 0 if not
-               zindic        = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi04 ) ) !=1 if hi > 1e-3 and 0 if not
+               zindsn        = MAX( rzero, SIGN( rone, v_s(ji,jj,jl) - epsi10 ) ) !=1 if hs > 1e-10 and 0 if not
+               zindic        = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi10 ) ) !=1 if hi > 1e-10 and 0 if not
                ! bug fix 25 avril 2007
                zindb         = zindb*zindic
@@ -444,5 +368,4 @@
                !--- 2.7 Correction to ice concentrations 
                !--------------------------------------------
-               !clem a_i(ji,jj,jl) = zindb * MAX(zindsn, zindic) * MAX( a_i(ji,jj,jl), epsi06 )
                a_i(ji,jj,jl) = zindb * a_i(ji,jj,jl)
 
@@ -464,5 +387,5 @@
             DO jj = 1, jpj 
                DO ji = 1, jpi
-                  zindic        = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi04 ) ) 
+                  zindic        = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi10 ) ) 
                   e_i(ji,jj,jk,jl)= zindic * ( MIN ( MAX ( 0.0, e_i(ji,jj,jk,jl) ), zbigvalue ) )
                END DO ! ji
@@ -478,7 +401,7 @@
                !--- 2.12 Constrain the thickness of the smallest category above 5 cm
                !----------------------------------------------------------------------
-               zindb         = MAX( rzero, SIGN( rone, a_i(ji,jj,jl) - epsi06 ) ) 
-               ht_i(ji,jj,jl) = zindb*v_i(ji,jj,jl)/MAX(a_i(ji,jj,jl), epsi06)
-               zh            = MAX( rone , zindb * hiclim  / MAX( ht_i(ji,jj,jl) , epsi20 ) )
+               zindb         = MAX( rzero, SIGN( rone, a_i(ji,jj,jl) - epsi10 ) ) 
+               ht_i(ji,jj,jl) = zindb*v_i(ji,jj,jl)/MAX(a_i(ji,jj,jl), epsi10)
+               zh            = MAX( rone , zindb * hiclim  / MAX( ht_i(ji,jj,jl) , epsi10 ) )
                ht_s(ji,jj,jl) = ht_s(ji,jj,jl)* zh
                ht_i(ji,jj,jl) = ht_i(ji,jj,jl)* zh
@@ -502,11 +425,11 @@
          DO ji = 1, jpi
             z_da_ex =  MAX( at_i(ji,jj) - amax , 0.0 )        
-            zindb   =  MAX( rzero, SIGN( rone, at_i(ji,jj) - epsi06 ) ) 
+            zindb   =  MAX( rzero, SIGN( rone, at_i(ji,jj) - epsi10 ) ) 
             DO jl  = 1, jpl
-               z_da_i = a_i(ji,jj,jl) * z_da_ex / MAX( at_i(ji,jj), epsi06 ) * zindb
+               z_da_i = a_i(ji,jj,jl) * z_da_ex / MAX( at_i(ji,jj), epsi10 ) * zindb
                a_i(ji,jj,jl) = MAX( 0._wp, a_i(ji,jj,jl) - z_da_i )
                !
-               zinda   =  MAX( rzero, SIGN( rone, a_i(ji,jj,jl) - epsi06 ) ) 
-               ht_i(ji,jj,jl) = v_i(ji,jj,jl) / MAX( a_i(ji,jj,jl), epsi06 ) * zinda
+               zinda   =  MAX( rzero, SIGN( rone, a_i(ji,jj,jl) - epsi10 ) ) 
+               ht_i(ji,jj,jl) = v_i(ji,jj,jl) / MAX( a_i(ji,jj,jl), epsi10 ) * zinda
                !v_i(ji,jj,jl) = ht_i(ji,jj,jl) * a_i(ji,jj,jl) ! makes ice shrinken but should not be used
             END DO
@@ -542,6 +465,6 @@
                      !clem smv_i(ji,jj,jl)  =  MAX(MIN((rhoic-rhosn)/rhoic*sss_m(ji,jj),smv_i(ji,jj,jl)),0.1 * v_i(ji,jj,jl) )
                      smv_i(ji,jj,jl) = MAX( MIN( s_i_max * v_i(ji,jj,jl), smv_i(ji,jj,jl) ), s_i_min * v_i(ji,jj,jl) )
-                     i_ice_switch    = 1._wp - MAX( 0._wp, SIGN( 1._wp, -v_i(ji,jj,jl) + epsi20 ) )
-                     smv_i(ji,jj,jl) = i_ice_switch * smv_i(ji,jj,jl) + s_i_min * ( 1._wp - i_ice_switch ) * v_i(ji,jj,jl)
+                     i_ice_switch    = 1._wp - MAX( 0._wp, SIGN( 1._wp, -v_i(ji,jj,jl) ) )
+                     smv_i(ji,jj,jl) = i_ice_switch * smv_i(ji,jj,jl) !+ s_i_min * ( 1._wp - i_ice_switch ) * v_i(ji,jj,jl)
                   END DO ! ji
                END DO ! jj
@@ -663,5 +586,4 @@
             CALL prt_ctl(tab2d_1=old_oa_i   (:,:,jl)        , clinfo1= ' lim_update2  : old_oa_i    : ')
             CALL prt_ctl(tab2d_1=d_oa_i_thd (:,:,jl)        , clinfo1= ' lim_update2  : d_oa_i_thd  : ')
-            CALL prt_ctl(tab2d_1=REAL(patho_case(:,:,jl))   , clinfo1= ' lim_update2  : Path. case  : ')
 
             DO jk = 1, nlay_i
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limvar.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limvar.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limvar.F90	(revision 4333)
@@ -66,9 +66,5 @@
    PUBLIC   lim_var_salprof1d    !
 
-   REAL(wp) ::   epsi20 = 1.e-20_wp   ! module constants
-   REAL(wp) ::   epsi16 = 1.e-16_wp   !    -       -
-   REAL(wp) ::   epsi13 = 1.e-13_wp   !    -       -
    REAL(wp) ::   epsi10 = 1.e-10_wp   !    -       -
-   REAL(wp) ::   epsi06 = 1.e-06_wp   !    -       -
    REAL(wp) ::   zzero = 0.e0        !    -       -
    REAL(wp) ::   zone  = 1.e0        !    -       -
@@ -117,6 +113,6 @@
                at_i(ji,jj) = at_i(ji,jj) + a_i(ji,jj,jl) ! ice concentration
                !
-               zinda = MAX( zzero , SIGN( zone , at_i(ji,jj) - epsi16 ) ) 
-               icethi(ji,jj) = vt_i(ji,jj) / MAX( at_i(ji,jj) , epsi16 ) * zinda  ! ice thickness
+               zinda = MAX( zzero , SIGN( zone , at_i(ji,jj) - epsi10 ) ) 
+               icethi(ji,jj) = vt_i(ji,jj) / MAX( at_i(ji,jj) , epsi10 ) * zinda  ! ice thickness
             END DO
          END DO
@@ -138,9 +134,9 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  zinda = MAX( zzero , SIGN( zone , vt_i(ji,jj) - epsi16 ) ) 
-                  zindb = MAX( zzero , SIGN( zone , at_i(ji,jj) - epsi16 ) ) 
+                  zinda = MAX( zzero , SIGN( zone , vt_i(ji,jj) - epsi10 ) ) 
+                  zindb = MAX( zzero , SIGN( zone , at_i(ji,jj) - epsi10 ) ) 
                   et_s(ji,jj)  = et_s(ji,jj)  + e_s(ji,jj,1,jl)                                       ! snow heat content
-                  smt_i(ji,jj) = smt_i(ji,jj) + smv_i(ji,jj,jl) / MAX( vt_i(ji,jj) , epsi16 ) * zinda   ! ice salinity
-                  ot_i(ji,jj)  = ot_i(ji,jj)  + oa_i(ji,jj,jl)  / MAX( at_i(ji,jj) , epsi16 ) * zindb   ! ice age
+                  smt_i(ji,jj) = smt_i(ji,jj) + smv_i(ji,jj,jl) / MAX( vt_i(ji,jj) , epsi10 ) * zinda   ! ice salinity
+                  ot_i(ji,jj)  = ot_i(ji,jj)  + oa_i(ji,jj,jl)  / MAX( at_i(ji,jj) , epsi10 ) * zindb   ! ice age
                END DO
             END DO
@@ -209,6 +205,6 @@
                DO ji = 1, jpi
                   !                                                              ! Energy of melting q(S,T) [J.m-3]
-                  zq_i    = e_i(ji,jj,jk,jl) / area(ji,jj) / MAX( v_i(ji,jj,jl) , epsi06 ) * REAL(nlay_i,wp) 
-                  zindb   = 1.0 - MAX( 0.0 , SIGN( 1.0 , - v_i(ji,jj,jl) ) )     ! zindb = 0 if no ice and 1 if yes
+                  zq_i    = e_i(ji,jj,jk,jl) / area(ji,jj) / MAX( v_i(ji,jj,jl) , epsi10 ) * REAL(nlay_i,wp) 
+                  zindb   = 1.0 - MAX( 0.0 , SIGN( 1.0 , - v_i(ji,jj,jl) + epsi10 ) )     ! zindb = 0 if no ice and 1 if yes
                   zq_i    = zq_i * unit_fac * zindb                              !convert units
                   ztmelts = -tmut * s_i(ji,jj,jk,jl) + rtt                       ! Ice layer melt temperature
@@ -235,6 +231,6 @@
                DO ji = 1, jpi
                   !Energy of melting q(S,T) [J.m-3]
-                  zq_s  = e_s(ji,jj,jk,jl) / ( area(ji,jj) * MAX( v_s(ji,jj,jl) , epsi06 ) ) * REAL(nlay_s,wp)
-                  zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp , - v_s(ji,jj,jl) ) )     ! zindb = 0 if no ice and 1 if yes
+                  zq_s  = e_s(ji,jj,jk,jl) / ( area(ji,jj) * MAX( v_s(ji,jj,jl) , epsi10 ) ) * REAL(nlay_s,wp)
+                  zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp , - v_s(ji,jj,jl) + epsi10 ) )     ! zindb = 0 if no ice and 1 if yes
                   zq_s  = zq_s * unit_fac * zindb                                    ! convert units
                   !
@@ -341,4 +337,5 @@
                   zind01 = ( 1._wp - zind0 ) * MAX( 0._wp   , SIGN( 1._wp  , s_i_1 - sm_i(ji,jj,jl) ) ) 
                   ! If 2.sm_i GE sss_m then zindbal = 1
+                  ! this is to force a constant salinity profile in the Baltic Sea
                   zindbal = MAX( 0._wp , SIGN( 1._wp , 2._wp * sm_i(ji,jj,jl) - sss_m(ji,jj) ) )
                   zalpha(ji,jj,jl) = zind0  + zind01 * ( sm_i(ji,jj,jl) * dummy_fac0 + dummy_fac1 )
@@ -434,9 +431,9 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  zinda = (  1._wp - MAX( 0._wp , SIGN( 1._wp , (t_i(ji,jj,jk,jl) - rtt) + epsi16 ) )  )
-                  zindb = (  1._wp - MAX( 0._wp , SIGN( 1._wp , - vt_i(ji,jj) + epsi16 ) )  )
-                  zbvi  = - zinda * tmut * s_i(ji,jj,jk,jl) / MIN( t_i(ji,jj,jk,jl) - rtt, - epsi16 )   &
+                  zinda = (  1._wp - MAX( 0._wp , SIGN( 1._wp , (t_i(ji,jj,jk,jl) - rtt) + epsi10 ) )  )
+                  zindb = (  1._wp - MAX( 0._wp , SIGN( 1._wp , - vt_i(ji,jj) + epsi10 ) )  )
+                  zbvi  = - zinda * tmut * s_i(ji,jj,jk,jl) / MIN( t_i(ji,jj,jk,jl) - rtt, - epsi10 )   &
                      &                   * v_i(ji,jj,jl)    / REAL(nlay_i,wp)
-                  bv_i(ji,jj) = bv_i(ji,jj) + zindb * zbvi  / MAX( vt_i(ji,jj) , epsi16 )
+                  bv_i(ji,jj) = bv_i(ji,jj) + zindb * zbvi  / MAX( vt_i(ji,jj) , epsi10 )
                END DO
             END DO
@@ -498,4 +495,5 @@
                zind01 = ( 1._wp - zind0 ) * MAX( 0._wp , SIGN( 1._wp , s_i_1 - sm_i_b(ji) ) ) 
                ! if 2.sm_i GE sss_m then zindbal = 1
+               ! this is to force a constant salinity profile in the Baltic Sea
                zindbal = MAX( 0._wp , SIGN( 1._wp , 2._wp * sm_i_b(ji) - sss_m(ii,ij) ) )
                !
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limwri.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limwri.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limwri.F90	(revision 4333)
@@ -52,5 +52,5 @@
    INTEGER            , DIMENSION(jpnoumax) ::   nc  , nca     ! switch for saving field ( = 1 ) or not ( = 0 )
 
-   REAL(wp)  ::   epsi06 = 1e-6_wp
+   REAL(wp)  ::   epsi06 = 1.e-6_wp
    REAL(wp)  ::   zzero  = 0._wp
    REAL(wp)  ::   zone   = 1._wp      
@@ -192,10 +192,10 @@
 
       !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-      IF( ln_nicep ) THEN
-         WRITE(numout,*)
-         WRITE(numout,*) 'lim_wri : write ice outputs in NetCDF files at time : ', nyear, nmonth, nday, numit
-         WRITE(numout,*) '~~~~~~~ '
-         WRITE(numout,*) ' kindic = ', kindic
-      ENDIF
+      !IF( ln_nicep ) THEN
+      !   WRITE(numout,*)
+      !   WRITE(numout,*) 'lim_wri : write ice outputs in NetCDF files at time : ', nyear, nmonth, nday, numit
+      !   WRITE(numout,*) '~~~~~~~ '
+      !   WRITE(numout,*) ' kindic = ', kindic
+      !ENDIF
       !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 
@@ -570,4 +570,15 @@
       CALL histdef( kid, "iicevolu", "Ice volume"              , "m"      , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt ) 
       CALL histdef( kid, "iicedive", "Ice divergence"          , "10-8s-1", jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt ) 
+      CALL histdef( kid, "iicebopr", "Ice bottom production"   , "m/s"      , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt )
+      CALL histdef( kid, "iicedypr", "Ice dynamic production"  , "m/s"      , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt )
+      CALL histdef( kid, "iicelapr", "Ice open water prod"     , "m/s"      , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt )
+      CALL histdef( kid, "iicesipr", "Snow ice production "    , "m/s"      , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt )
+      CALL histdef( kid, "iicerepr", "Ice prod from limupdate" , "m/s"      , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt )
+      CALL histdef( kid, "iicebome", "Ice bottom melt"         , "m/s"      , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt )
+      CALL histdef( kid, "iicesume", "Ice surface melt"        , "m/s"      , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt )
+      CALL histdef( kid, "iisfxthd", "Salt flux from thermo"   , ""      , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt )
+      CALL histdef( kid, "iisfxmec", "Salt flux from dynmics"  , ""      , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt )
+      CALL histdef( kid, "iisfxres", "Salt flux from limupdate", ""      , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt )
+
 
       !CALL histdef( kid, "iice_itd", "Ice concentration by cat", "%"      , jpi, jpj, kh_i, jpl, 1, jpl, -99, 32, "inst(x)", rdt, rdt ) 
@@ -592,4 +603,15 @@
       CALL histwrite( kid, "iicedive", kt, divu_i*1.0e8   , jpi*jpj, (/1/) )
 
+      CALL histwrite( kid, "iicebopr", kt, diag_bot_gr        , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicedypr", kt, diag_dyn_gr        , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicelapr", kt, diag_lat_gr        , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicesipr", kt, diag_sni_gr        , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicerepr", kt, diag_res_pr        , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicebome", kt, diag_bot_me        , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicesume", kt, diag_sur_me        , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iisfxthd", kt, sfx_thd        , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iisfxmec", kt, sfx_mec        , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iisfxres", kt, sfx_res        , jpi*jpj, (/1/) )
+
       !CALL histwrite( kid, "iice_itd", kt, a_i  , jpi*jpj*jpl, (/1/)  )   ! area
       !CALL histwrite( kid, "iice_hid", kt, ht_i , jpi*jpj*jpl, (/1/)  )   ! thickness
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 4333)
@@ -104,7 +104,7 @@
    REAL(wp),    DIMENSION(jp_bdy) ::   rn_time_dmp_out          !: Damping time scale in days at radiation outflow points
 
-#if defined key_lim2
-   CHARACTER(len=20), DIMENSION(jp_bdy) ::   nn_ice_lim2      ! Choice of boundary condition for sea ice variables 
-   INTEGER, DIMENSION(jp_bdy)           ::   nn_ice_lim2_dta  !: = 0 use the initial state as bdy dta ; 
+#if ( defined key_lim2 || defined key_lim3 )
+   CHARACTER(len=20), DIMENSION(jp_bdy) ::   nn_ice_lim       ! Choice of boundary condition for sea ice variables 
+   INTEGER, DIMENSION(jp_bdy)           ::   nn_ice_lim_dta   !: = 0 use the initial state as bdy dta ; 
                                                               !: = 1 read it in a NetCDF file
 #endif
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 4333)
@@ -197,5 +197,5 @@
 
 #if defined key_lim2
-            IF( nn_ice_lim2_dta(ib_bdy) .eq. 0 ) THEN 
+            IF( nn_ice_lim_dta(ib_bdy) .eq. 0 ) THEN 
                ilen1(:) = nblen(:)
                IF( dta%ll_frld ) THEN
@@ -649,5 +649,5 @@
 #if defined key_lim2
             ! sea ice
-            IF( nn_ice_lim2_dta(ib_bdy) .eq. 1 ) THEN
+            IF( nn_ice_lim_dta(ib_bdy) .eq. 1 ) THEN
 
                IF( dta%ll_frld ) THEN
@@ -724,4 +724,5 @@
                ENDIF
 
+            ENDIF
 #endif
             ! Recalculate field counts
@@ -850,5 +851,5 @@
 #if defined key_lim2
          IF (nn_ice_lim(ib_bdy) .gt. 0) THEN
-            IF( nn_ice_lim2_dta(ib_bdy) .eq. 0 ) THEN
+            IF( nn_ice_lim_dta(ib_bdy) .eq. 0 ) THEN
                ALLOCATE( dta_bdy(ib_bdy)%frld(nblen(1)) )
                ALLOCATE( dta_bdy(ib_bdy)%hicif(nblen(1)) )
